<template>
  <div class="createPost-container">
    <el-form ref="postForm" :model="postForm" :rules="rules" class="form-container">

      <sticky :class-name="'sub-navbar'">
        <el-button v-loading="loading" style="margin-left: 10px;" type="success" @click="submitForm">保存
        </el-button>
      </sticky>

      <div class="createPost-main-container">
        <el-row>
          <el-col :span="24">
            <el-form-item style="margin-bottom: 40px;" prop="name">
              <MDinput v-model="postForm.name" :maxlength="100" name="name" required>
                标签名称
              </MDinput>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="24">
            <div class="postInfo-container">
              <el-row>
                <el-col :span="12">
                  <el-form-item style="margin-bottom: 20px;" label-width="75px" label="标签ID:" prop="position"
                                v-if="isEdit">
                    <el-input :rows="1" v-model="postForm.id" type="number" class="article-textarea"
                              style="width: 300px" disabled/>
                  </el-form-item>
                </el-col>
                <el-col :span="12">
                  <el-form-item style="margin-bottom: 20px;" label-width="75px" label="创建时间:" prop="position"
                                v-if="isEdit">
                    <el-input :rows="1" v-model="postForm.create_time" type="text" class="article-textarea"
                              style="width: 300px" disabled/>
                  </el-form-item>
                </el-col>
              </el-row>
            </div>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label-width="75px" label="上级标签:" class="postInfo-container-item">
              <el-select v-model="postForm.up_tags" :remote-method="getRemoteTagList" filterable remote multiple
                         value-key="id"
                         placeholder="搜索标签" style="width: 70%">
                <el-option v-for="(item,index) in TagListOptions" :key="item+index" :label="item.name"
                           :value="item.id"/>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">

            <el-form-item label-width="75px" label="下级标签:" class="postInfo-container-item">
              <el-select
                v-model="postForm.down_tags"
                :remote-method="getRemoteTagList"
                multiple
                filterable
                remote
                reserve-keyword
                placeholder="搜索标签"
                style="width: 70%"
                :loading="loading"
                value-key="id"
              >
                <el-option v-for="(item, index) in TagListOptions" :key="item+index" :label="item.name"
                           :value="item.id"/>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-form-item style="margin-bottom: 40px;" label-width="75px" label="标签简介:" prop="desc">
          <el-input :rows="1" v-model="postForm.description" type="textarea" class="article-textarea" autosize
                    placeholder="请输入内容"/>
          <span v-show="contentShortLength" class="word-counter">{{ contentShortLength }}字</span>
        </el-form-item>
      </div>
    </el-form>

  </div>
</template>

<script>
  import MDinput from '@/components/MDinput'
  import Sticky from '@/components/Sticky' // 粘性header组件
  import {fetchTagDetail, CreateTag} from '@/api/tag'
  import {tagSearch} from '@/api/remoteSearch'
  import {isInArray, removeByvale} from "@/utils";

  function Assembledata(target, source) {
    var region_data = []
    for (var i = 0; i < target.length; i++) {
      if (isInArray(source, target[i]['name'])) {
        region_data.push(target[i]['id'])
        removeByvale(source, target[i]['name']);
      }
    }
    region_data.push(...source)
    return region_data.join(',')
  }

  const defaultForm = {
    status: 'draft',
    name: '',
    description: '',
    up_tags: [],
    down_tags: [],
  }

  export default {
    name: 'TagDetail',
    components: {MDinput, Sticky},
    props: {
      isEdit: {
        type: Boolean,
        default: false
      }
    },
    data() {
      const validateRequire = (rule, value, callback) => {
        if (value === '') {
          this.$message({
            message: rule.field + '为必传项',
            type: 'error'
          })
          callback(new Error(rule.field + '为必传项'))
        } else {
          callback()
        }
      }
      return {
        postForm: Object.assign({}, defaultForm),
        loading: false,
        TagListOptions: [],
        rules: {
          name: [{validator: validateRequire, trigger: 'blur'}],
        },
        tempRoute: {},
        temparray: {
          'up_tags': [],
          'down_tags': [],
        }
      }
    },
    computed: {
      contentShortLength() {
        return this.postForm.description.length
      }
    },
    created() {
      if (this.isEdit) {
        const id = this.$route.params && this.$route.params.id
        this.fetchData(id)
      } else {
        this.postForm = Object.assign({}, defaultForm)
      }

      this.tempRoute = Object.assign({}, this.$route)
    },
    methods: {
      fetchData(id) {
        fetchTagDetail(id).then(response => {
          // select 回填数据处理，后期再进行优化
          let rep = response.data.data.data;
          let up_temp = []
          let down_temp = []
          for (let i = 0; i < rep.up_tags.length; i++) {
            up_temp.push(rep.up_tags[i]['name']);
            this.temparray['up_tags'].push(rep.up_tags[i])
          }
          console.log(rep.down_tags.length)
          for (let i = 0; i < rep.down_tags.length; i++) {
            down_temp.push(rep.down_tags[i]['name']);
            this.temparray['down_tags'].push(rep.down_tags[i])
          }
          rep.down_tags = down_temp
          rep.up_tags = up_temp
          this.postForm = rep
          console.log(this.postForm)
        }).catch(err => {
          console.log(err)
        })
      },
      submitForm() {
        this.$refs.postForm.validate(valid => {
          if (valid) {
            this.loading = true;
            if (this.isEdit) {
              this.postForm.up_tags = Assembledata(this.temparray['up_tags'], this.postForm.up_tags);
              this.postForm.down_tags = Assembledata(this.temparray['down_tags'], this.postForm.down_tags);
            } else {
              this.postForm.up_tags = this.postForm.up_tags.join(',')
              this.postForm.down_tags = this.postForm.down_tags.join(',')
            }

            let flag = false;
            let up_tag_arrays = this.postForm.up_tags.split(',')
            let down_tags_arrays = this.postForm.down_tags.split(',')

            for (let i = 0; i< up_tag_arrays.length; i++){
              if (isInArray(down_tags_arrays, up_tag_arrays[i])){
                this.$message.error('上下级标签不能存相同标签')
                this.postForm.up_tags = [];
                this.postForm.down_tags = [];
                flag = true;
                break
              }
            }
            if (flag){
              return false;
            }

            CreateTag(this.postForm).then(response => {
              this.$notify({
                title: '成功',
                message: response.data.data.message,
                type: 'success',
                duration: 2000
              })
              setTimeout(() => {
                this.$router.push('/tag/list')
              }, 1000)

            }).catch(err => {
              this.$notify({
                title: '失败',
                message: '操作失败',
                type: 'danger',
                duration: 2000
              })
            });


            this.postForm.status = 'published'
            this.loading = false
          } else {
            console.log('error submit!!')
            return false
          }
        })
      },
      getRemoteTagList(query) {
        tagSearch(query).then(response => {
          if (!response.data.data.data) return
          this.TagListOptions = response.data.data.data
        })
      },
    }
  }
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  @import "src/styles/mixin.scss";

  .createPost-container {
    position: relative;
    .createPost-main-container {
      padding: 40px 45px 20px 50px;
      .postInfo-container {
        position: relative;
        @include clearfix;
        margin-bottom: 10px;
        .postInfo-container-item {
          float: left;
        }
      }
      .editor-container {
        min-height: 500px;
        margin: 0 0 30px;
        .editor-upload-btn-container {
          text-align: right;
          margin-right: 10px;
          .editor-upload-btn {
            display: inline-block;
          }
        }
      }
    }
    .word-counter {
      width: 40px;
      position: absolute;
      right: -10px;
      top: 0px;
    }
  }
</style>
